// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function util_checkFanpa(str = ''){
    const searchString = "This item is sold out";
    const regex = new RegExp(searchString);
    const containsString = regex.test(str);
    if(containsString){
        return true;
    } else {
        return false;
    }
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_list_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_list';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_list: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_list: 0}, callback);
            }else{
                chrome.storage.local.set({pause_list: 1}, callback);
            }
        }
    });
}

// Function to convert an image to a Blob
async function imageToBlob(imageUrl) {
  try {
    // Fetch the image as an array buffer
    const response = await fetch(imageUrl);
    const arrayBuffer = await response.arrayBuffer();

    // Create a Blob from the array buffer
    const blob = new Blob([arrayBuffer], { type: response.headers.get("content-type") });

    return blob;
  } catch (error) {
    console.error("Error converting image to Blob:", error);
    return null;
  }
}

// Usage example:
/*const imageUrl = "https://img.kwcdn.com/product/Fancyalgo/VirtualModelMatting/8af63f79afdd388711b1c34289c15cda.jpg?imageView2/2/w/800/q/70/format/webp";
imageToBlob(imageUrl)
  .then(blob => {
    if (blob) {
      // Do something with the Blob, such as uploading it or displaying it
        console.log('aaaa');
        console.log(blob);
    } else {
        console.log("Failed to convert image to Blob.");
    }
  });*/

function urlToBase64(url, callback) {
  const xhr = new XMLHttpRequest();
  xhr.onload = function() {
    const reader = new FileReader();
    reader.onloadend = function() {
      callback(reader.result);
    };
    reader.readAsDataURL(xhr.response);
  };
  xhr.open('GET', url);
  xhr.responseType = 'blob';
  xhr.send();
}

// 使用示例
/*const imageUrl = 'https://example.com/image.jpg'; // 替换为你自己的图片URL
urlToBase64(imageUrl, function(base64String) {
  console.log(base64String); // 这里是Base64编码的图片字符串
});*/
//

function util_getscript_goodsDetailV3SsrData_content(html=''){
    // 示例HTML代码
    // 正则表达式匹配<script>标签内容的模式
    var scriptTagPattern = /<script\b[^>]*>([\s\S]*?)<\/script>/gm;
    var matches = html.match(scriptTagPattern);
    if (matches) {
        for (var i = 0; i < matches.length; i++) {
            // 提取<script>标签里的内容
            var scriptContent = matches[i].replace(scriptTagPattern, '$1');
            if(scriptContent.indexOf('goodsDetailV3SsrData') !=-1){
               return scriptContent;
            }
        }
    }
    return false;
}

function storage_shangjia_about_contact_and_basic_info_set(_shangjia_info={},local_num=1, callback){
    let prefix = 'shangjia_about_contact_and_basic_info_'+$.md5(_shangjia_info['_shangjia_id']);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_id': _shangjia_info['_shangjia_id'],
                '_shangjia_name': _shangjia_info['_shangjia_name'],
                '_shangjia_goods_sn':'',
                '_shangjia_catalog_1': '',
                '_shangjia_catalog_last': '',
                '_shangjia_about_contact_and_basic_info_link':_shangjia_info['_shangjia_a_link'],

                '_is_request':0,
                '_shangjia_img': _shangjia_info['_shangjia_img'],
                '_shangjia_main_origin_image':'',
                '_shangjia_images': '',

                '_shangjia_img_blob': '',
                '_shangjia_price': _shangjia_info['_shangjia_price'],
                '_shangjia_old_price': _shangjia_info['_shangjia_old_price'],
                '_shangjia_data_discount':_shangjia_info['_shangjia_data_discount'],

                '_shangjia_review_score': _shangjia_info['_shangjia_review_score'],
                '_shangjia_reivew_num': _shangjia_info['_shangjia_reivew_num'],
                '_shangjia_sold': _shangjia_info['_shangjia_sold'],
                '_shangjia_total_sold_num': _shangjia_info['_shangjia_total_sold_num'],
                '_shangjia_proposition_rank':_shangjia_info['_shangjia_proposition_rank'],
                '_shangjia_proposition_rank_category':_shangjia_info['_shangjia_proposition_rank_category'],

                '_shangjia_market_place':_shangjia_info['_shangjia_market_place'],
                '_shangjia_tag_Activity':_shangjia_info['_shangjia_tag_Activity'],
                '_shangjia_flashsalebelts':_shangjia_info['_shangjia_flashsalebelts'],
                '_shangjia_color_count':_shangjia_info['_shangjia_color_count'],
                '_shangjia_new':_shangjia_info['_shangjia_new'],
                '_shangjia_sku':_shangjia_info['_shangjia_sku'],

                '_shangjia_desc':'',

                '_shangjia_store_name': '',
                '_shangjia_store_url': '',
                '_shangjia_store_logo': '',
                'num':(total_add_shangjia_num+1)
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}

function request_shangjia_about_contact_and_basic_info_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        //
        $.ajax({
            url:need_item['_shangjia_about_contact_and_basic_info_link'],
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               //
               let _mainContent = _dom.find('.mainContent').text();
               let _baseContent = _dom.find('.baseContent').text();
               let _checkContent = _mainContent;
               if(_baseContent){
                   _checkContent += _baseContent;
               }
               if(util_checkFanpa(_checkContent)){
                   //
                    need_item['_is_request'] = 0;
                    need_item['_error'] = '遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                            //

                            //
                    });
                    sendPopTips("遇到反爬,请开启或者更换代理或者暂停采集，稍后再采集!");
                    //
               }else{
                   //
                   let _goodsDetailV3SsrData = util_getscript_goodsDetailV3SsrData_content(data);
                   let _goodsDetailV3SsrData_json = {};
                   if(_goodsDetailV3SsrData){
                       //
                       _goodsDetailV3SsrData_arr = _goodsDetailV3SsrData.split('//物流运费展示');
                       if(_goodsDetailV3SsrData_arr.length ==2){
                           _goodsDetailV3SsrData = _goodsDetailV3SsrData_arr[0];
                           _goodsDetailV3SsrData = _goodsDetailV3SsrData.replace('window.goodsDetailV3SsrData =','');
                           _goodsDetailV3SsrData = _goodsDetailV3SsrData.trim();
                           _goodsDetailV3SsrData_json = JSON.parse(_goodsDetailV3SsrData);
                           console.log('_goodsDetailV3SsrData_json');
                           console.log(_goodsDetailV3SsrData_json);
                           need_item['_shangjia_reivew_num'] = _goodsDetailV3SsrData_json['productIntroData']['commentInfo']['comment_num'];
                           need_item['_shangjia_review_score'] = _goodsDetailV3SsrData_json['productIntroData']['commentInfo']['comment_rank_average'];
                           need_item['_shangjia_goods_sn'] = _goodsDetailV3SsrData_json['productIntroData']['detail']['goods_sn'];
                           need_item['_shangjia_price'] = _goodsDetailV3SsrData_json['productIntroData']['detail']['salePrice']['amountWithSymbol'];
                           need_item['_shangjia_img'] = _goodsDetailV3SsrData_json['productIntroData']['detail']['goods_img'];
                           need_item['_shangjia_main_origin_image'] = _goodsDetailV3SsrData_json['productIntroData']['goods_imgs']['main_image']['origin_image'];
                           let _shangjia_images_arr = _goodsDetailV3SsrData_json['productIntroData']['goods_imgs']['detail_image'];
                           let _tmp_shangjia_images_arr = [];
                           for(let i_img=0;i_img<_shangjia_images_arr.length;i_img++){
                               _tmp_shangjia_images_arr.push(_shangjia_images_arr[i_img]['origin_image']);
                           }
                           let _shangjia_images = _tmp_shangjia_images_arr.join(',');
                           need_item['_shangjia_images'] = _shangjia_images;
                           need_item['_shangjia_catalog_1'] = _goodsDetailV3SsrData_json['productIntroData']['parentCats']['cat_name'];
                           need_item['_shangjia_catalog_last'] = _goodsDetailV3SsrData_json['productIntroData']['currentCat']['cat_name'];
                           //store
                           need_item['_shangjia_store_name'] = _goodsDetailV3SsrData_json['productIntroData']['storeInfo']['title'];
                           need_item['_shangjia_store_url'] = 'https://us.shein.com/store/home?store_code='+_goodsDetailV3SsrData_json['productIntroData']['storeInfo']['storeCode'];
                           need_item['_shangjia_store_logo'] = _goodsDetailV3SsrData_json['productIntroData']['storeInfo']['logo'];
                           //
                       }
                       //console.log('_goodsDetailV3SsrData_json');
                       //console.log(_goodsDetailV3SsrData_json);
                   }
                   //
                   //
                   need_item['_is_request'] = 2;
                   need_item['_e_time'] = Date.now();
                   let obj = {};
                   obj[storage_key] = need_item;
                   chrome.storage.local.set(obj, function (){
                   });
                   //
                   /*if(need_item['_shangjia_img']){
                       urlToBase64(need_item['_shangjia_img'], function(base64String) {
                           //console.log(blob);
                            //need_item['_shangjia_img_blob'] = base64String;
                            //
                            need_item['_is_request'] = 2;
                            need_item['_e_time'] = Date.now();
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                            });
                            //
                        });
                   }*/
                   //
               }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                if(jqXHR.status == '404'){
                    need_item['_is_request'] = 2;
                }else{
                    need_item['_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;

                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                        //

                        //
                });
                //
                if(jqXHR.status != '404'){
                    sendPopTips("遇到反爬,请开启或者更换代理或者暂停采集或者查看代理是否打开，稍后再采集!", need_item['_shangjia_about_contact_and_basic_info_link']);
                }
            }
        });
        //
    })
}

function request_shangjia_about_contact_and_basic_info(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') > -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-10000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_about_contact_and_basic_info_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function xintiao(){
     chrome.storage.local.get(null, function(items) {
         if(items.hasOwnProperty('pause') == false || items['pause'] == 0){
             console.log('爬取中');
             request_shangjia_about_contact_and_basic_info();
         }else{
             console.log('已暂停爬取');
         }
    });

    //request_shangjia_about_work_and_education_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });
    //let str = '';

    //let _dom = $(str);
    //https://www.facebook.com/gabriella.obi.77/about_work_and_education
    //
    //let _shangjia_company_page_link = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').attr('href');
    //console.log(_shangjia_company_page_link);

    //let _shangjia_company_page_name = _dom.find('.x1gan7if span.xvq8zen a.x1a2a7pz.xt0b8zv').text();
    //console.log(_shangjia_company_page_name);
}
xintiao();
setInterval(xintiao, 10000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_about_contact_and_basic_info_') > -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_about_work_and_education_') > -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'shangjias'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_geren_num = 0;
    let has_caiji_company_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_about_contact_and_basic_info_') > -1){
                total_add_shangjia_num += 1;
                if(items[key]['_is_request'] == 2){
                    has_caiji_geren_num += 1;
                }
            }

        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_geren_num': has_caiji_geren_num,
            'has_caiji_company_num': has_caiji_company_num,
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_shangjias_update(shangjia_infos=[]){
    //console.log('storage_shangjias_update a');
    chrome.storage.local.get('shangjias', function(items) {
        //console.log('storage_shangjias_update b');
        //console.log(items);
        if(!items.hasOwnProperty('shangjias')){
            let obj = {};
            let shangjias = [];
            for(let i=0;i<shangjia_infos.length;i++){
                shangjias.push(shangjia_infos[i]['_shangjia_id']);
            }
            obj['shangjias'] = shangjias;
            chrome.storage.local.set(obj);
        }else{
            let storage_shangjias = items['shangjias'];

            for(let i=0;i<shangjia_infos.length;i++){
                let is_exists = false;
                for(let j=0;j<storage_shangjias.length;j++){
                    if(shangjia_infos[i]['_shangjia_id'] == storage_shangjias[j]){
                        is_exists = true;
                        break;
                    }
                }
                //
                if(!is_exists){
                    storage_shangjias.push(shangjia_infos[i]['_shangjia_id']);
                }
                //
            }
            //
            let obj = {};
            obj['shangjias'] = storage_shangjias;
            chrome.storage.local.set(obj);
            //
        }
    })
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'shangjia_items_update') {
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        //storage_shangjias_update(shangjia_infos);
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_about_contact_and_basic_info_set(shangjia_infos[i],(i+1),function (){

            });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_list_caiji'){
        console.log('can_list_caiji',request,sender,sendResponse);
        //判断，如果加入超过5000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_about_contact_and_basic_info_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 30000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
        });
        //
        return true;
    }
  }
);

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */

function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}